<?php
class Dan extends Super{

  protected $id;
  protected $nazev;
  protected $koeficient;
  protected $procenta; //vypočítaná hodnota
  protected $popis;
  protected $stav = 1;  // default stav 

  protected $getter = array('id', 'nazev', 'koeficient', 'procenta', 'popis', 'stav');
  protected $setter = array( 'nazev', 'koeficient', 'popis', 'stav');
  public $validate = array(
  	'id'     => array('digits' => 'true'),
  	'nazev'  => array('required' => 'true', 'maxlength' => 35),
  	'koeficient'  => array('number' => 'true'),
  	'procenta'		=> array('required' => 'true', 'numberDE' => 'true'),
    'stav'   => array('range' => '[0,1]' )
  );
	public $label = array(
  	'id'     => 'Id',
  	'nazev'  => 'Název',
  	'koeficient' => 'Koef.',
		'procenta'	 => 'Procent',
    'popis' 	 => 'Popis',
    'stav' 	 => 'Stav'
  );
  public $valAll = array(
  	'id'     => true,
  	'nazev'  => true,
  	'koeficient' => true,
  	'procenta'	 => true,
    'stav' 		 => true
  );
	public $filtry = array(
      'ID' => array(
      	'type' => 'text',
				'key'	 => 'ID',
				'sql'	 => 'num',
    		'size' => 3
    	),
      'NAZEV' => array(
      	'type' => 'text',
    		'key'	 => 'NAZEV',
    		'sql'	 => 'text',
    		'size' => 12
    	),
      'S_NAZEV' => array(
      	'type' => 'stav',
    		'key'	 => 'STAV',
    		'sql'	 => 'num'
    	),
      'UPRAVIT' => array(
      	'type' => 'submit'
    	),
      'SMAZAT' => array(
      	'type' => 'all'
    	)
    );
  public $state_validate = array();

  function __construct() {
    /*
     * stavy:
     * 1 - aktivní
     * 2 - neaktivní
     */
    $this->state_validate[1] = $this->valAll;
    $this->state_validate[0] = $this->valAll;
    $this->table = 'DAN';

  }
  
  public function getToSelect() {
    $res = dibi::query('SELECT E.*
    	FROM ['.$this->table.'] AS E
    	WHERE STAV = %i',
         1);
    return $res->fetchAssoc('ID');
  }

  public function loadById($id, $hash = false, $postRestore = false) {
    $result = dibi::query('SELECT  E.*, S.NAZEV AS S_NAZEV, S.POPIS AS S_POPIS FROM ['.$this->table.'] AS E 
    	INNER JOIN STAV AS S ON S.STAV_ID = E.STAV AND ENTITA = %s
    	WHERE E.ID = %i;', $this->table, $id);

    if (count($result) == 0) {
      throw new Appliexception(1, 'Požadovaný záznam neexistuje', 'seznam', __METHOD__.' Neexistující záznam '.$id );
    }

    $row = $result->fetch()->getArrayCopy();
    $this->setFromRow($row);
    $this->my_stav = '<div title="'.$row['S_POPIS'].'" class="block_state"> '.$row['STAV'].' - '.$row['S_NAZEV'].'</div><br />';

    if ($hash) {
      $this->hash  = $this->getHash();
    } 

    $this->myStates();

    if ($postRestore) {
      $this->setFromPost();
    }
    return $this->toArray();
  }

  public function getAllQuery() {
  	$query = array();
  	$query[] = 'SELECT E.*, (E.KOEFICIENT*100 - 100) AS PROCENTA, S.NAZEV AS S_NAZEV
			FROM ['.$this->table.'] AS E';
  	array_push($query, 'INNER JOIN [STAV] S ON S.STAV_ID = E.STAV AND S.ENTITA = %s',$this->table );
  	return $query;
	}

	public function beforeInsert() {
		$_POST['procenta'] = Tools::numberFromDE($_POST['procenta']);
		$this->koeficient  = ($_POST['procenta'] / 100) + 1;
	}

	public function beforeUpdate() {
		$_POST['procenta'] = Tools::numberFromDE($_POST['procenta']);
		$this->koeficient  = ($_POST['procenta'] / 100) + 1;
	}

}
?>